/* $Id: art_tex.pov,v 1.6 2004/10/11 06:29:24 art Exp $ */

#include "colors.inc"

#declare Green1=rgb<230,170,50>/255;
#declare Green2=rgb<110,160,8>/255;
// --------------------------------------
// Grass texture
// --------------------------------------
#declare pigSpotted =pigment {
spotted
    color_map {
        [0.0, 0.2   color Tan*0.1 color Tan*0.4]
        [0.2, 0.3   color Tan*0.4 color Green1]
        [0.3, 1.01   color Green1 color Green1*1.2]
    }
}

#declare pigEarth =pigment {
    spotted
    color_map {
        [0 color Tan*0.3]
        [0.6 color Tan*0.3]
        [0.6 color Green1*0.4]
        [1   color Green1*0.4]
    }
}

#declare pigGreen=pigment{Green2*1.3}

#declare pigGrass3 = pigment{ pigEarth }
#declare pigGrass2 = pigment{ pigSpotted }
#declare pigGrass1 = pigment{ pigGreen }

#declare pigGrass1 = pigment { color rgb <65,132,12>/255 }
#declare pigGrass2 = pigment { color rgb <136,137,12>/255 }

#declare txtGrass=texture {                  
	pigment {
		gradient x
		pigment_map {                                
			[0.0	pigGrass1]
			[0.25	pigGrass2]
			[0.75	pigGrass3]
			[1.0	pigGrass1]
		}
		scale <0.5,1,1>
		turbulence 0.5
	}
        normal {
                gradient x
                slope_map {
                        [0   <0, 0>]
                        [0.5 <0.3, 0>]
                        [1   <0,0>]
                }
                scale <0.5,1,1>
                turbulence 0.5

        }
        finish{ambient 0.01 diffuse 0.7 specular 0.15 roughness 0.015}
} 


#declare pigMask = pigment {
	bozo
	color_map {
		[0.4 Black]
		[0.6 White]
	}
	scale 0.5
}

// Earth pigment (start)

#declare pig_earth1 = pigment {
	bozo
	color_map {
		[0.1 rgb <33/255, 43/255, 2/255> ]
		[0.9 rgb <11/255, 13/255, 0/255> ]
	}
	scale 0.1
}
#declare pig_earth2 = pigment {
	bozo
	color_map {
		[0.1 rgb <76/255, 45/255, 2/255> ]
		[0.9 rgb <23/255, 15/255, 0/255> ]
	}
	scale 0.1
}

#declare pig_earth = pigment {
	bozo
	pigment_map {
		[0.35 pig_earth1 ]
		[0.65 pig_earth2 ]
	}
	scale 0.2
}

// Earth pigment (end)

// Sand pigment (start)

#declare pig_sand = pigment {
	agate
	agate_turb 0.5
	color_map {
		[0.25 rgb <221/255, 223/255, 28/255> ]
		[0.85 rgb <169/255, 171/255, 21/255> ]
	}
	scale 0.4
}

// Sand pigment (end)

#declare tex_terrain = texture {
        image_pattern {
                png "bereg_mask2.png"
                map_type 0
        }
	texture_map {
		[0 pigment { pig_sand } ]
		[1 pigment { pig_earth } ]
	}
}

#declare pigWood1 = pigment {
        wood
        turbulence 0.005
        scale 0.25
        color_map {
          [0.10 color rgbt <0.49020, 0.22353, 0.00000, 0.00>]
          [0.16 color rgbt <0.71863, 0.69412, 0.46275, 0.00>]
          [0.20 color rgbt <0.49020, 0.22353, 0.00000, 0.00>]
          [0.25 color rgbt <0.76863, 0.69412, 0.46275, 0.00>]
          [0.32 color rgbt <0.44020, 0.22353, 0.00000, 0.00>]
          [0.37 color rgbt <0.74863, 0.69412, 0.46275, 0.00>]
          [0.40 color rgbt <0.49020, 0.20353, 0.00000, 0.00>]
          [0.45 color rgbt <0.76863, 0.66412, 0.48275, 0.00>]
          [0.51 color rgbt <0.49020, 0.22353, 0.00000, 0.00>]
          [0.55 color rgbt <0.76863, 0.67059, 0.37255, 0.00>]
          [0.61 color rgbt <0.49020, 0.25353, 0.00000, 0.00>]
          [0.65 color rgbt <0.76863, 0.67059, 0.37255, 0.00>]
          [0.70 color rgbt <0.49020, 0.22353, 0.00000, 0.00>]
          [0.75 color rgbt <0.76863, 0.63059, 0.37255, 0.00>]
          [0.82 color rgbt <0.49020, 0.22353, 0.00000, 0.00>]
          [0.88 color rgbt <0.77863, 0.67059, 0.37255, 0.00>]
          [0.91 color rgbt <0.49020, 0.22353, 0.00000, 0.00>]
          [0.95 color rgbt <0.79863, 0.67059, 0.39550, 0.00>]
          [1.00 color rgbt <0.48020, 0.22353, 0.00000, 0.00>]
        }
}

#declare pigWood2 = pigment {
        bozo
        pigment_map {
                [0 pigWood1]
                [1 color rgb <0.5, 0.8, 0.0>]
        }
}

#declare texMetal1 = texture {
	pigment { color rgb <0.60, 0.30, 0.15> }
	finish {
		ambient 0.25
		brilliance 4
		diffuse 0.5
		metallic
		specular 0.80
		roughness 1/80
		reflection 0.2
	}
}

#declare texMetal2 = texture {
	pigment { color rgb <0.20, 0.10, 0.05> }
	finish {
		ambient 0.15
		brilliance 4
		diffuse 0.5
		metallic
		specular 0.60
		roughness 1/80
		reflection 0.05
	}

}

#declare texMetal3 = texture {
	pigment { color rgb <0.50, 0.20, 0.1> }
	finish {
		ambient 0.20
		brilliance 4
		diffuse 0.5
		metallic
		specular 0.80
		roughness 1/80
		reflection 0.1
	}
}

#declare texMetal4 = texture {
	bozo
	texture_map {
		[0.4 texMetal1]
		[0.6 texMetal3]
	}
}

#declare tex_ostov1 = texture {
	pigment { color rgb <255/255,225/255,122/255> }
	finish { specular 0.7 }
}
#declare tex_ostov2 = texture {
	pigment { color rgb <195/255,64/255,0> }
	finish { specular 0.0 }
}
#declare tex_ostov3 = texture {
	gradient x
	texture_map {
		[0.0 tex_ostov1]
		[0.5 tex_ostov2]
		[1.0 tex_ostov1]
	}
	turbulence 0.2
	rotate z*30
	scale 0.03
}

#declare tex_ostov4 = texture {
	pigment { color rgb <255/255,225/255,122/255> * <0.35,0.5,0.2> }
	finish { specular 0.7 }
}
#declare tex_ostov5 = texture {
	pigment { color rgb <195/255,64/255,0> * <0.35,0.5,0.2> }
	finish { specular 0.0 }
}
#declare tex_ostov6 = texture {
	gradient x
	texture_map {
		[0.0 tex_ostov4]
		[0.5 tex_ostov5]
		[1.0 tex_ostov4]
	}
	turbulence 0.2
	rotate z*30
	scale 0.03
}

#declare tex_ostov = texture {
	bozo
	texture_map {
		[0.4 tex_ostov3 scale 1/0.025]
		[0.6 tex_ostov6 scale 1/0.025]
	}
	scale 0.025
}

/////////////////////////
// RZHAVCHINA
/////////////////////////

#declare texTrans = texture {
	pigment{ color rgbt <0,0,0,1> } 
	finish { specular 0.0 ambient 0.0 diffuse 0.0 reflection 0.0 }
}

#declare texRzh1_1 = texture {
	pigment { color rgb <100, 62, 1> / 255 }
	finish { specular 0.2 }
}

#declare texRzh1_2 = texture {
	pigment { color rgb <196, 110, 26> / 255 }
	finish { specular 0.2 }
}

#declare texRzh1_3 = texture {
	pigment { color rgb <146, 132, 117> / 255 / 8 }
	finish { specular 0.7 }
}

#declare texRzh1 = texture {
	agate
	texture_map {
		[0.3 texRzh1_1]
		[0.6 texRzh1_2]
		[0.9 texRzh1_3]
	}
}

#declare texRzh2 = texture {
	pigment { color rgb <180, 166, 145> / 255 }
	//finish { specular 0.6 reflection 0.5}
	finish { specular 0.0 ambient 0.0 diffuse 0.0 reflection 0.0 }
}

#declare texRzh3 = texture {
	bozo
	texture_map {
		[0.75 texRzh1 scale 2]
		[0.8 texRzh2]
	}
}


#declare texRzhavchina = texture {
	bozo
	texture_map {
		[0.3 texTrans]
		[0.3 texRzh3] 
	}
	scale 0.1
}

