/* $Id: bottle.pov,v 1.2 2004/10/13 12:19:39 art Exp $ */

#declare bottleScale = 1.5;
#declare bottleRotate = <0, -45, -75>;
#declare bottleTranslate = <0.3, -1.1, -3.2>;
	
#declare SOR = sor {
        9,
        <0, 0.0>
        <1.2, 0.0>
        <1.2, 0.6>
        <0.8, 0.7>

        <0.55, 0.9>
        <0.6, 0.93>
        <0.55, 0.96>
	
        <0.55, 1.0>
        <0, 1.0>
        scale <0.28, 2.8, 0.28>
        sturm
}

#local minExt = min_extent( SOR );
#local maxExt = max_extent( SOR );

#local texTrans = texture { pigment { color rgb <1, 1, 0.9> transmit 0.0 } }

#local texLogoBig1 = texture {
	pigment {
		image_map {
			png "povlogo.png"
			map_type 0
			interpolate 2
		//	once
		}
        	scale y * 0.09
	        translate y*0.03
	}
	normal {
		crackle
		slope_map {
			[0.0 <0,0>]
			[0.1 <1,1>]
			[0.1 <1,0>]
			[1.0 <0.25,0>]
		}
		scale <0.005, 0.0025, 0.005>
	}
	finish {
		ambient 0.2 diffuse 0.6 specular 0.3
	}
}

// dirt
#local texLogoBig2 = texture {
	pigment {
		image_map {
			png "povlogo_green.png"
			map_type 0
			interpolate 2
			once
		}
        	scale y * 0.09
	        translate y*0.03
	}
	normal {
		crackle
		slope_map {
			[0.0 <0,0>]
			[0.1 <1,1>]
			[0.1 <1,0>]
			[1.0 <0.25,0>]
		}
		scale <0.005, 0.0025, 0.005>
	}
	normal {
		bumps 0.2
		scale <0.005, 0.0025, 0.005>
	}

	finish {
		ambient 0.1 diffuse 0.2 specular 0.15
	}
}

#local texLogoBig3 = texture {
	agate
	texture_map {
		[0.45 texLogoBig1
			scale 1/<0.01, 0.002, 0.01>
		]
		[0.55 texLogoBig2
			scale 1/<0.01, 0.002, 0.01>
		]
	}
	scale <0.01, 0.002, 0.01>
}

#local texLogoBig4 = texture {
	bozo
	texture_map {
		[0.45 texLogoBig1
			scale 1/<0.1, 0.02, 0.1>
		]
		[0.55 texLogoBig3
			scale 1/<0.1, 0.02, 0.1>
		]
	}
	scale <0.1, 0.02, 0.1>
}

#local textureRotate = bottleRotate + <0,0,-70>;
#local textureScale = 0.5;

#local texLogoBig = texture {
	gradient y
	texture_map {
		[0.35 texLogoBig4
			scale 1/textureScale
			rotate -z * textureRotate.z
		]
		[0.45 texLogoBig1
			scale 1/textureScale
			rotate -z * textureRotate.z
		]
		[0.5 texLogoBig3
			scale 1/textureScale
			rotate -z * textureRotate.z

		]
		[0.55 texLogoBig2
			scale 1/textureScale
			rotate -z * textureRotate.z

		]
	}
	scale textureScale
	rotate z * textureRotate.z
}

union {
        difference {
                object { SOR }
                object { SOR scale <0.7, 1.05, 0.7> translate y*0.02 }
                texture {
                        pigment { color rgb <0.5,0.9,0.9> transmit 0.9 }
                }
		normal {
			granite 0.1
			scale 0.1
		}
                interior {
			ior 1.2
			fade_power 2
			fade_distance 0.7
		}
        }

        difference {
                intersection {
                        difference {
                                object { SOR }
                                object { SOR scale <0.99, 1, 0.99> }
                        }
			box { <minExt.x, minExt.y + (maxExt.y-minExt.y)*0.11, minExt.z>, <maxExt.x, minExt.y + (maxExt.y-minExt.y)*0.43, maxExt.z>
			}
                }
                uv_mapping
                #declare P1 = 0.03;
                #declare P2 = 0.12;
                texture {
                        gradient y
                        texture_map {
                                [P1 texTrans]
                                [P1 texLogoBig]
                                [P2 texLogoBig]
                                [P2 texTrans]
                        }
                }
                scale <1.01, 1, 1.01>
        }

	scale bottleScale
	rotate bottleRotate
        translate bottleTranslate
}

