/* $Id: giantgrass.pov,v 1.5 2004/10/11 06:29:24 art Exp $ */

#include "grass/artgrass.pov"

// --------------------------------------
// Patch parameters
// --------------------------------------
// Final number of triangles = nBlade x nBlade x segBlade x 2 (or 4 if dofold = true)
// --------------------------------------
#declare nBlade=200;                // number of blades
#declare ryBlade = 0;            // initial y rotation of blade
#declare segBlade= 16;            // number of blade segments

#if( grassHi )
	#declare segBlade = segBlade * 2;
#end

#declare lBlade = 5.0;             // length of blade
#declare wBlade = 0.2;              // width of blade at start
#declare wBladeEnd = 0.01;         // width of blade at the end
#declare doSmooth=true;          // true makes smooth triangles
#declare startBend = <0,1,0.3>;   // bending of blade at start (<0,1,0>=no bending)
#declare vBend = <0,-0.5,0>;         // force bending the blade (<0,1,1> = 45)
#declare pwBend = 3;              // bending power (how slowly the curve bends)
// 779
#declare rd = 12345;                // seed
#declare stdposBlade = 1;         // standard deviation of blade position 0..1
#declare stdrotBlade = 360;       // standard deviation of rotation
#declare stdBlade = 1.2;           // standard deviation of blade scale;
#declare stdBend = 2;            // standard deviation of blade bending;
#declare dofold = true;          // true creates a central fold in the blade (twice more triangles)
#declare dofile = true;          // true creates a mesh file
#declare fname1 = "giantgrass.inc"     // name of the mesh file to create
#declare fname2 = "backgrass.inc"     // name of the mesh file to create

#declare backBox = box {
	0,1
	scale <terrScale.x*1.5, 0.1, terrScale.z>
	translate <terrOffset.x*1.5, terrOffset.y, terrOffset.z>
	translate z*terrScale.z
}


#if( showGiantGrass )
	#if (dofile=true)
		PlantGrass(terrain, pigGiantGrassMask,nBlade,ryBlade,segBlade,lBlade,wBlade,wBladeEnd,doSmooth,startBend,vBend,pwBend,rd,stdposBlade,stdrotBlade,stdBlade,stdBend,dofold,dofile,fname1)
		#declare giantgrass=#include fname1
		
		PlantGrass(backBox, pigment{ color White },nBlade*3,ryBlade,segBlade/2,lBlade*1.5,wBlade*1.5,wBladeEnd,doSmooth,startBend,vBend,pwBend,rd,stdposBlade,stdrotBlade,stdBlade,stdBend,dofold,dofile,fname2)
		#declare backgrass=#include fname2
	#else        
		#declare giantgrass=object{PlantGrass(terrain, pigGiantGrassMask,nBlade,ryBlade,segBlade,lBlade,wBlade,wBladeEnd,doSmooth,startBend,vBend,pwBend,rd,stdposBlade,stdrotBlade,stdBlade,stdBend,dofold,dofile,fname1)}
		#declare backgrass=object{PlantGrass(backBox, pigment{ color White },nBlade,ryBlade,segBlade,lBlade,wBlade,wBladeEnd,doSmooth,startBend,vBend,pwBend,rd,stdposBlade,stdrotBlade,stdBlade,stdBend,dofold,dofile,fname2)}
	#end        
#end


