/* $Id: artgrass.pov,v 1.5 2004/09/27 15:02:23 art Exp $ */
#include "transforms.inc"
#include "grass/mgrass.pov"

#macro MakeBlade2(doSmooth,posBlade,rotBlade,segBlade,lBlade,xBladeStart,xBladeEnd,zBladeStart,startBend,vBend,pwBend,dofold,dofile)
#local lsegBlade=lBlade/segBlade;
#if (dofold=true)
        #local nI=3;
#else
        #local nI=2;
#end                
#local nJ=segBlade+1;
#local nP=nI*nJ;
#local P=array[nP]
#local N=array[nP]  
#local pBlade=<0,0,0>;              
#local Count=0;                                       
#local xBlade=xBladeStart;
#local zBlade=zBladeStart;
#if (dofold=true)
        #local P[0]=vaxis_rotate(-x*xBlade,y,rotBlade)+posBlade;
        #local P[1]=vaxis_rotate(z*zBlade,y,rotBlade)+posBlade;
        #local P[2]=vaxis_rotate(x*xBlade,y,rotBlade)+posBlade;
#else
        #local P[0]=vaxis_rotate(-x*xBlade,y,rotBlade)+posBlade;
        #local P[1]=vaxis_rotate(x*xBlade,y,rotBlade)+posBlade;

#end
#local Count=1; 
#local pBlade=vnormalize(startBend)*lsegBlade;
// --------------------------------------
// Fills the array of points
// --------------------------------------
#while (Count<nJ)          
        #local tBlade=Count/segBlade;
        // This is where the blade shape is defined
        #local pBlade=pBlade+lsegBlade*vnormalize(vnormalize(pBlade)+ vBend*pow(tBlade,pwBend));
        #local xBlade=xBladeStart+tBlade*(xBladeEnd-xBladeStart);
        #if (dofold=true)
                #local zBlade=zBladeStart*(1-tBlade);
                #local P[Count*nI]=vaxis_rotate(pBlade-x*xBlade,y,rotBlade)+posBlade;
                #local P[Count*nI+1]=vaxis_rotate(pBlade+z*zBlade,y,rotBlade)+posBlade;
                #local P[Count*nI+2]=vaxis_rotate(pBlade+x*xBlade,y,rotBlade)+posBlade;
        #else
                #local P[Count*nI]=vaxis_rotate(pBlade-x*xBlade,y,rotBlade)+posBlade;
                #local P[Count*nI+1]=vaxis_rotate(pBlade+x*xBlade,y,rotBlade)+posBlade;
        #end
        #local Count=Count+1;        
#end
// --------------------------------------
// Calculates normals if doSmooth = true
// --------------------------------------
#if (doSmooth=true)
#local N = array[nP] // Normales
#local q=0;
#while (q<nP)
#local i=mod(q,nI);#local j=(q-i)/nI;
#local V0 = q-nI-1;#if (i=0) #local V0=-1; #end
#local V1 = q-nI;
#local V2 = q-nI+1;#if (i=nI-1) #local V2=-1; #end
#local V3 = q-1;#if (i=0) #local V3=-1; #end
#local V4 = q;
#local V5 = q+1;#if (i=nI-1) #local V5=-1; #end
#local V6 = q+nI-1;#if (i=0) #local V6=-1; #end
#local V7 = q+nI;
#local V8 = q+nI+1;#if (i=nI-1) #local V8=-1; #end

#if (j=0) #local V0=-1;#local V1=-1;#local V2=-1;#end
#if (j=nJ-1) #local V6=-1;#local V7=-1;#local V8=-1; #end

#local N[q]=<0,0,0>;
#local k=0;
#if (V5>-1 & V8>-1) #local N[q]=N[q]+vcross(P[V4]-P[V5],P[V8]-P[V4]);#local k=k+1;#end
#if (V2>-1 & V5>-1) #local N[q]=N[q]+vcross(P[V4]-P[V2],P[V5]-P[V4]);#local k=k+1;#end
#if (V1>-1 & V2>-1) #local N[q]=N[q]+vcross(P[V4]-P[V1],P[V2]-P[V4]);#local k=k+1;#end
#if (V0>-1 & V1>-1) #local N[q]=N[q]+vcross(P[V4]-P[V0],P[V1]-P[V4]);#local k=k+1;#end
#if (V3>-1 & V0>-1) #local N[q]=N[q]+vcross(P[V4]-P[V3],P[V0]-P[V4]);#local k=k+1;#end
#if (V6>-1 & V3>-1) #local N[q]=N[q]+vcross(P[V4]-P[V6],P[V3]-P[V4]);#local k=k+1;#end
#if (V7>-1 & V6>-1) #local N[q]=N[q]+vcross(P[V4]-P[V7],P[V6]-P[V4]);#local k=k+1;#end
#if (V8>-1 & V7>-1) #local N[q]=N[q]+vcross(P[V4]-P[V8],P[V7]-P[V4]);#local k=k+1;#end
#local N[q]=N[q]/k;
#local q=q+1;#end
#end
// --------------------------------------
// Writes the triangles
// --------------------------------------
#local q=0;
#if(dofile=true)
	#write(filehandle, "mesh2 { vertex_vectors {",nP,"\n")
#else
mesh2 {
vertex_vectors {
        nP
#end
        #while (q<nP)
		#if(dofile=true)
			#write(filehandle,P[ q ],"\n")
		#else
        	        P[ q ]
		#end
                #local q=q+1;
        #end
#if(dofile=true)
	#write(filehandle, "}\n")
#else
}
#end

#if(dofile=true)
	#write(filehandle,"uv_vectors { ",nP,"\n")
#else
uv_vectors {
        nP
#end
        #local i = 0;
        #local zMap = 0.0;
        #while( i <= segBlade )
		#if(dofile=true)
	                #if (dofold=true)
				#write(filehandle,"<0,",zMap,">,<0.5,",zMap,">,<1,",zMap,">\n")
                	#else
				#write(filehandle,"<0,",zMap,">,<1,",zMap,">\n")
	                #end
		#else
	                #if (dofold=true)
        	                <0,zMap>,<0.5,zMap>,<1,zMap>
                	#else
                        	<0,zMap>,<1,zMap>
	                #end
		#end
                #local i = i + 1;
                #local zMap = zMap + 1/segBlade;
        #end
#if(dofile=true)
	#write(filehandle, "}\n")
#else
}
#end

#if (doSmooth=true)
#local q=0;

#if(dofile=true)
	#write(filehandle,"normal_vectors { ", nP,"\n")
#else
normal_vectors {
        nP
#end
        #while (q<nP)
		#if(dofile=true)
			#write(filehandle, N[ q ], "\n")
		#else
	                N[ q ]
		#end
                #local q=q+1;
        #end
	#if(dofile=true)
		#write(filehandle,"}\n")
	#else
		}
	#end
#end

#if (dofile=true)
	#write(filehandle,"face_indices {", segBlade * (nI - 1) * 2,"\n")
#else
	face_indices { segBlade * (nI - 1) * 2
#end

#local q=0;
#while (q<(nI*(nJ-1)-1))
#local i=mod(q,nI);

#if (i <nI-1)
                #if (dofile=true)
                        #write(filehandle,"<",q,",",q+1,",",q+nI+1,">\n")
                        #write(filehandle,"<",q,",",q+nI,",",q+nI+1,">\n")
		#else
			<q,q+1,q+nI+1>
			<q,q+nI,q+nI+1>
		#end
#end
#local q=q+1;
#end

#if (dofile=true)
	#write(filehandle, "}\n}\n")
#else
	}
	}
#end


#end // end of the macro


//==============================================
// MakeGrassSphere macro
//==============================================
// The MakeGrassSphere macro creates a grass sphere by creating
// individual blades with the MakeBlade macro
// The main tuning parameters are segBlade and nBlade (keep low to test) 
// --------------------------------------
// --------------------------------------
// Sphere parameters
// --------------------------------------
/*
#declare rSphere=50;               // size of patch
#declare nBlade=40;               // number of blades on sphere
#declare ryBlade = 60;            // initial y rotation of blade
#declare segBlade= 15;            // number of blade segments
#declare lBlade = 15;             // length of blade
#declare wBlade = 1;              // width of blade at start
#declare wBladeEnd = 0.3;         // width of blade at the end
#declare doSmooth=false;          // true makes smooth triangles
#declare startBend = <0,1,0.3>;   // bending of blade at start (<0,1,0>=no bending)
#declare vBend = <0,-1,2>;       // direction of the force bending the blade (<0,1,1> = 45)
#declare pwBend = 3;             // bending power (how slowly the curve bends)
#declare rd = 459;                // seed
#declare stdposBlade = 1;         // standard deviation of blade position 0..1
#declare stdrotBlade = 360;       // standard deviation of rotation
#declare stdBlade = 3;           // standard deviation of blade scale;
#declare stdBend = 0;             // standard deviation of blade bending;
#declare dofold = false;          // true creates a central fold in the blade (twice more triangles)
#declare dofile = true;           // true creates a mesh file
#declare fname = "fgrass.inc"     // name of the mesh file to create
// --------------------------------------
*/
#macro MakeGrassSphere(rSphere,nBlade,ryBlade,segBlade,lBlade,wBlade,wBladeEnd,doSmooth,startBend,vBend,pwBend,rd,stdposBlade,stdrotBlade,stdBlade,stdBend,dofold,dofile,fname)
#if(dofile=true)          
        #warning concat(fname," mesh file creation starts\n")

        #fopen filehandle fname write  // creates the leaf mesh (individual leaf)
        #write(filehandle,"mesh{\n")
        #else
        mesh{
#end
#local s1=seed(rd);
#local zCount=0;
#while (zCount<nBlade)
        #local xCount=0;                          
        
        #while (xCount<nBlade)                                          

		#local posBlade = vtransform( <rSphere, 0, 0>, Rotate_Around_Trans( <0, 180*rand(s1), 180*rand(s1)>, <0, 0, 0> ) );
                #local rotBlade=ryBlade+(0.5-rand(s1))*stdrotBlade;
                #local scBlade=max(0.5,(0.5-rand(s1))*stdBlade*2);
                #local lBladetmp=lBlade*scBlade;     
                #local xBladeStart=wBlade*scBlade;
                #local xBladeEnd=wBladeEnd*scBlade;
                #local zBladeStart=xBladeStart*0.5;
                #local vBendtmp=vBend + <(0.5-rand(s1))*0.3,0.5-rand(s1),rand(s1)>*stdBend;
                MakeBlade(doSmooth,posBlade,rotBlade,segBlade,lBladetmp,xBladeStart,xBladeEnd,zBladeStart,startBend,vBendtmp,pwBend,dofold,dofile)

                #local xCount=xCount+1;
        #end
        #local zCount=zCount+1;
#end

#if(dofile = true)
        #write (filehandle,"}\n")
        #fclose filehandle
        #warning concat(fname," file created\n")
#else
        }
        
#end

#end
// --------------------------------------
// End of the MakeGrassSphere macro
//==============================================

//==============================================
// PlantGrass macro
//==============================================
// The MakeGrass macro creates a grass sphere by creating
// individual blades with the MakeBlade macro
// The main tuning parameters are segBlade and nBlade (keep low to test) 
// --------------------------------------
// --------------------------------------
// Sphere parameters
// --------------------------------------
/*
#declare nBlade=40;               // number of blades on sphere
#declare ryBlade = 60;            // initial y rotation of blade
#declare segBlade= 15;            // number of blade segments
#declare lBlade = 15;             // length of blade
#declare wBlade = 1;              // width of blade at start
#declare wBladeEnd = 0.3;         // width of blade at the end
#declare doSmooth=false;          // true makes smooth triangles
#declare startBend = <0,1,0.3>;   // bending of blade at start (<0,1,0>=no bending)
#declare vBend = <0,-1,2>;       // direction of the force bending the blade (<0,1,1> = 45)
#declare pwBend = 3;             // bending power (how slowly the curve bends)
#declare rd = 459;                // seed
#declare stdposBlade = 1;         // standard deviation of blade position 0..1
#declare stdrotBlade = 360;       // standard deviation of rotation
#declare stdBlade = 3;           // standard deviation of blade scale;
#declare stdBend = 0;             // standard deviation of blade bending;
#declare dofold = false;          // true creates a central fold in the blade (twice more triangles)
#declare dofile = true;           // true creates a mesh file
#declare fname = "fgrass.inc"     // name of the mesh file to create
// --------------------------------------
*/
#macro PlantGrass(Object, Pigment,nBlade,ryBlade,segBlade,lBlade,wBlade,wBladeEnd,doSmooth,startBend,vBend,pwBend,rd,stdposBlade,stdrotBlade,stdBlade,stdBend,dofold,dofile,fname)
#if(dofile=true)          
        #debug concat(fname," mesh file creation starts\n")

        #fopen filehandle fname write  // creates the leaf mesh (individual leaf)
        #write(filehandle,"union{\n")
#else
        union {
#end
#local s1=seed(rd);
#local Count=0;

#local min_ext = min_extent( Object );
#local max_ext = max_extent( Object );
#local max_ext = max_ext + y;
#local dim = max_ext - min_ext;
#local norm = <0,0,0>;
#local statEvery = 100;
#local statN = statEvery;

#while (Count<nBlade)

		#local start = min_ext + dim * <rand(s1), rand(s1), rand(s1)>;
		#local posBlade = trace( Object, start, start*<0,-1,0>, norm );

		#if( vlength( norm ) != 0 )
			#if( eval_pigment( Pigment, posBlade ).gray > rand(s1) )
				#local rotBlade=ryBlade+(0.5-rand(s1))*stdrotBlade;
				#local scBlade=max(0.5,(0.5-rand(s1))*stdBlade*2);
				#local lBladetmp=lBlade*scBlade;     
				#local xBladeStart=wBlade*scBlade;
				#local xBladeEnd=wBladeEnd*scBlade;
				#local zBladeStart=xBladeStart*0.5;
				#local vBendtmp=vBend + <(0.5-rand(s1))*0.3,0.5-rand(s1),rand(s1)>*stdBend;
				MakeBlade2(doSmooth,posBlade,rotBlade,segBlade,lBladetmp,xBladeStart,xBladeEnd,zBladeStart,startBend,vBendtmp,pwBend,dofold,dofile)

				#local Count=Count+1;
				#local statN=statN-1;
				#if( statN = 0 )
					#debug concat( str( nBlade-Count, 0, 2), " blades left\n" )
					#local statN=statEvery;
				#end
			#end
		#end
#end
#if(dofile = true)
        #write (filehandle,"}\n")
        #fclose filehandle
        #debug concat(fname," file created\n")
#else
        }
#end

#end
// --------------------------------------
// End of the PlantGrass macro
//==============================================

