/* $Id$ */

#version 3.5;

#include "colors.inc"
#include "grass/artgrass.pov"
#include "art_tex.pov"

global_settings {
  assumed_gamma 1.0
}

// ----------------------------------------

camera {
        location  <0.0, 2.5, -7.0>
        direction 1.5*z
        right     x*image_width/image_height
        look_at   <0.0, 1.5,  0.0>
}

/*
camera {
        location  <0.0, 2.5, -2.0>
        direction 1.5*z
        right     x*image_width/image_height
        look_at   <0.0, 1.0,  0.0>
}
*/

sky_sphere {
  pigment {
    gradient y
    color_map {
      [0.0 rgb <0.6,0.7,1.0>]
      [0.7 rgb <0.0,0.1,0.8>]
    }
  }
}

light_source {
  <0, 0, 0>            // light's position (translated below)
  color rgb <1, 1, 1>  // light's color
  translate <-30, 30, -30>
}

// --------------------------------------
// Patch parameters
// --------------------------------------
// Final number of triangles = nBlade x nBlade x segBlade x 2 (or 4 if dofold = true)
// --------------------------------------
#declare nBlade=50;                // number of blades
#declare ryBlade = 0;            // initial y rotation of blade
#declare segBlade= 16;            // number of blade segments
#declare lBlade = 5.0;             // length of blade
#declare wBlade = 0.15;              // width of blade at start
#declare wBladeEnd = 0.01;         // width of blade at the end
#declare doSmooth=true;          // true makes smooth triangles
#declare startBend = <0,1,0.2>;   // bending of blade at start (<0,1,0>=no bending)
#declare vBend = <0,-0.5,0.0>;         // force bending the blade (<0,1,1> = 45)
#declare pwBend = 3;              // bending power (how slowly the curve bends)
#declare rd = 12345;                // seed
#declare stdposBlade = 1;         // standard deviation of blade position 0..1
#declare stdrotBlade = 360;       // standard deviation of rotation
#declare stdBlade = 1.2;           // standard deviation of blade scale;
#declare stdBend = 6;            // standard deviation of blade bending;
#declare dofold = true;          // true creates a central fold in the blade (twice more triangles)
#declare dofile = true;          // true creates a mesh file
#declare fname = "testgrass.inc"     // name of the mesh file to create

// ----------------------------------------
#declare sandBox = box {
        -2,2
        scale <1,0.05,1>
        pigment {
                crackle
                turbulence 0.3
                color_map {
                        [0 color rgb <0.2, 0.1, 0.0>]
                        [0.1 color rgb <0.9, 0.85, 0.0>]
                }
                scale 0.1
        }
}

#if(dofile=true)
        //PlantGrass(sandBox, pigment{color rgb 1},nBlade,ryBlade,segBlade,lBlade,wBlade,wBladeEnd,doSmooth,startBend,vBend,pwBend,rd,stdposBlade,stdrotBlade,stdBlade,stdBend,dofold,dofile,fname)
        #declare grass=#include fname
#else
        #declare grass = PlantGrass(sandBox, pigment{color rgb 1},nBlade,ryBlade,segBlade,lBlade,wBlade,wBladeEnd,doSmooth,startBend,vBend,pwBend,rd,stdposBlade,stdrotBlade,stdBlade,stdBend,dofold,dofile,fname)
#end

object {
        grass
        uv_mapping
        texture {
		txtGrass scale 0.2
	}
}

object { sandBox }

/*
#local numSeg = 5;
#local numPoints = (numSeg+1)*2;
#local P = array[ numPoints ];
#local i = 0;
#local baseP = <0,0,0>;
#local w = 1;
#local l = 3;

#while( i <= numSeg )
        #local P[ i * 2 + 0 ] = baseP - x*w;
        #local P[ i * 2 + 1 ] = baseP + x*w;
        #local i = i + 1;
        #local baseP = baseP + z*l/numSeg;
        #local w = w - 0.3*i/numSeg;
#end


mesh2 {
   vertex_vectors {
      numPoints
      #local i = 0;
      #while( i < numPoints )
        P[ i ]
        #local i = i + 1;
      #end
   }

   uv_vectors {
      numPoints
      #local i = 0;
      #local zMap = 0.0;
      #while( i <= numSeg )
        <0,zMap>,<1,zMap>
        #local i = i + 1;
        #local zMap = zMap + 1/numSeg;
      #end
   }

   face_indices {
      numSeg*2
      #local i = 0;
      #while( i < numSeg*2 )
        <i,i+1,i+2>
        #local i = i + 1;
      #end            
   }
   
   uv_mapping

   texture {
     txtGrass scale 5
   }
}*/