/* $Id: hata.pov,v 1.6 2004/10/11 06:29:24 art Exp $ */

#if( showHata )

#include "functions.inc"
#include "metals.inc"
#include "art_tex.pov"

#declare door_rad = 1;
#declare door_scale = <1.5, 1, 1>;
#declare door_thick = 0.08;
#declare door_kosyak_thick = 0.2;
#declare door_min_dosk_width = 0.1;
#declare door_max_dosk_width = 0.14;

#declare okno_rad = 1;
#declare okno_scale = <1, 1, 1>;
#declare okno_thick = 0.2;
#declare okno_kosyak_thick = 0.2;
#declare okno_dosk_width = 0.1;

#declare maxang=130;
#declare dang=5;
#declare currang=0;
#declare begrad=1;
#declare endrad=0.02;
#declare base_sphere_rad=0.05;

#declare ostov = difference {
	union {
		#while( currang <= maxang )                    
			#declare percent = currang / maxang;
			#declare currrad = begrad * (1 - percent) + percent * endrad;

			torus {
				currrad, 0.05 * (1 - percent )
				
				texture { tex_ostov }
				
				rotate y * currang / 2
				scale <1, 2, 1>
				translate -x * begrad
				rotate -z * currang
			}

			#declare currang = currang + dang * 0.5 + 0.5 * dang * (1 - percent);
		#end
	}
	cylinder {
		<0, -0.1, 0>, <0, 1.0, 0>, okno_rad

		scale 0.17
		rotate <45, -13, 90>
		translate -z*0.50
		translate -x*0.32
		translate y*0.45
	}
	cylinder {
		<0, 0, 0>, <0, 1.0, 0>, door_rad
		scale door_scale
		scale 0.2
		rotate <75, -24, 90>
		translate -z*0.90
		translate -x*0.8
		translate y*0.35
	}
}

//////////////////////////////////////////
// DOOR
//////////////////////////////////////////


#declare dver = union {
	// ruchka
	union {
		cylinder {
			-door_kosyak_thick * x,
			door_kosyak_thick * x,
			door_kosyak_thick * 0.15

			translate y * door_kosyak_thick / 2
		}
		cylinder {
			-door_kosyak_thick * x,
			-door_kosyak_thick * x + y * door_kosyak_thick / 2,
			door_kosyak_thick * 0.15
		}
		cylinder {
			door_kosyak_thick * x,
			door_kosyak_thick * x + y * door_kosyak_thick / 2,
			door_kosyak_thick * 0.15
		}
		sphere {
			-door_kosyak_thick * x + y * door_kosyak_thick / 2,
			door_kosyak_thick * 0.2
		}
		sphere {
			door_kosyak_thick * x + y * door_kosyak_thick / 2,
			door_kosyak_thick * 0.2
		}
		texture { texRzh3 scale 0.05 }
		translate <door_rad / 6, door_thick, door_rad - 4 * door_kosyak_thick / 5> * door_scale
	}

	// petlya
	union {
		cylinder {
			-door_kosyak_thick * x * 1.5,
			door_kosyak_thick * x * 1.5,
			door_kosyak_thick * 0.4
			translate y * door_kosyak_thick / 2
			texture {
				gradient x
				texture_map {
					[0.07 texRzh3 scale 0.05]
					
					[0.07 texMetal2]
					[0.1 texMetal2]
					
					[0.1 texRzh3 scale 0.05]
					[0.33 texRzh3 scale 0.05]
					
					[0.33 texMetal2]
					[0.37 texMetal2]
					
					[0.37 texRzh3 scale 0.05]
					[0.63 texRzh3 scale 0.05]
					
					[0.63 texMetal2]
					[0.67 texMetal2]
					
					[0.67 texRzh3 scale 0.05]
					[0.9 texRzh3 scale 0.05]
					
					[0.9 texMetal2]
					[0.97 texMetal2]
					
					[0.97 texRzh3 scale 0.05]
				}
				scale door_kosyak_thick * 3
				translate door_kosyak_thick * x * 1.5 
			}
		}
		box {
			< -door_kosyak_thick * 1.4, -door_kosyak_thick * 0.1, door_kosyak_thick*0.5 >
			< door_kosyak_thick * 1.4, door_kosyak_thick * 0.1, 0 >
		}
		cylinder {
			-y*door_kosyak_thick * 0.1
			y*door_kosyak_thick * 0.1
			door_kosyak_thick * 1.4
			scale <1,1,0.4>
			translate z*door_kosyak_thick*0.5
		}
		texture { texRzh3 scale 0.05 }

		translate <0, door_thick, -door_rad> * door_scale
	}

        // kosyak
        difference {
                cylinder {
                        <0, -door_thick*4, 0>, <0, door_thick, 0>, door_rad
                        scale door_scale
                }
                
                cylinder {
                        <0, -door_thick*4+0.01, 0>, <0, door_thick+0.01, 0>, door_rad - door_kosyak_thick
                        scale door_scale
                }
		texture {
			gradient x
			texture_map {
			        [0 	pigment { pigWood2 scale 0.1 }
					finish { ambient 0.1 diffuse 0.0 + 0.2 * rand( R1 ) specular 0.3 }
					rotate y*90]
				[.6 	pigment { pigWood1 }
					finish { ambient 0.1 diffuse 0.2 + 0.4 * rand( R1 ) specular 0.3 }
					rotate y*90]
			}
			scale <door_rad*2*door_scale.x, 1, 1>
			translate x*door_rad*door_scale.x
		}
        }
        
        // doski
        intersection {
                // sama dver
                union {
                        #declare point1 = <-door_rad, -4*door_thick, -door_rad > * door_scale;
                        #declare point2 = <door_rad, 0, -door_rad + door_min_dosk_width> * door_scale;

                        #while( point1.z < door_rad )
                                box {
                                        point1,
                                        point2
                                        texture {
						gradient x
						texture_map {
						        [0 	pigment { pigWood2 scale 0.1 }
								finish { ambient 0.1 diffuse 0.0 + 0.2 * rand( R1 ) specular 0.3 }
								rotate y*90]
							[.4 	pigment { pigWood1 }
								finish { ambient 0.1 diffuse 0.2 + 0.4 * rand( R1 ) specular 0.3 }
								rotate y*90]
						}
						scale <(door_rad-door_kosyak_thick)*2*door_scale.x, 1, 1>
						translate x*(door_rad-door_kosyak_thick)*door_scale.x
					}
                                }
                                #declare point1 = <point1.x, point1.y, point2.z + 0.03>;
                                #declare point2 = <point2.x, point2.y, point2.z + 0.03 + door_min_dosk_width + (door_max_dosk_width - door_min_dosk_width) * rand( R1 )>; 
                        #end

                        // krestik
                        box {
                                <-door_rad, door_thick * 0.5, -door_max_dosk_width > * door_scale,
                                <door_rad, door_thick * 0.75, door_max_dosk_width> * door_scale
				texture {
					gradient x
					texture_map {
					        [0 	pigment { pigWood2 scale 0.1 }
							finish { ambient 0.1 diffuse 0.0 + 0.2 * rand( R1 ) specular 0.3 }
							rotate y*90]
						[.4 	pigment { pigWood1 scale 3 }
							finish { ambient 0.1 diffuse 0.2 + 0.4 * rand( R1 ) specular 0.3 }
							rotate y*90]
					}
					scale <(door_rad-door_kosyak_thick)*2*door_scale.x,1,1>
					translate x*(door_rad-door_kosyak_thick)*door_scale.x
					
				}
                                rotate y*30
                        }
                        box {
                                <-door_rad, door_thick * 0.5, -door_max_dosk_width > * door_scale,
                                <door_rad, door_thick * 0.8, door_max_dosk_width> * door_scale
				texture {
					gradient x
					texture_map {
					        [0 	pigment { pigWood2 scale 0.1 }
							finish { ambient 0.1 diffuse 0.0 + 0.2 * rand( R1 ) specular 0.3 }
							rotate y*90]
						[.4 	pigment { pigWood1 scale 2 }
							finish { ambient 0.1 diffuse 0.2 + 0.4 * rand( R1 ) specular 0.3 }
							rotate y*90]
					}
					scale <(door_rad-door_kosyak_thick)*2*door_scale.x, 1, 1>
					translate x*(door_rad-door_kosyak_thick)*door_scale.x
				}
				rotate -y*30
                        }
                }
                        
                cylinder {
                        <0, -0.01, 0>, <0, door_thick+0.01, 0>, door_rad - door_kosyak_thick
                        scale door_scale
                }
        }

        pigment {
                color red 0.9 green 0.2 blue 0.2 // filter 0.8
        }

}

/////////////////////////////////////////////
// WINDOW
/////////////////////////////////////////////

#declare okno = union {
        // kosyak
        difference {
                cylinder {
                        <0, -4*okno_thick, 0>, <0, okno_thick, 0>, okno_rad
                        scale okno_scale
                }
                
                cylinder {
                        <0, -4.01*okno_thick, 0>, <0, okno_thick+0.01, 0>, okno_rad - okno_kosyak_thick
                        scale okno_scale
                }
		texture {
		        pigment { pigWood1 }
			finish { ambient 0.1 diffuse 0.2 + 0.4 * rand( R1 ) specular 0.3 }
			rotate y*90
			scale 0.5
		}
        }
        
        intersection {
                union {
                        
                        // krestik
                        box {
                                <-okno_rad, okno_thick * 0.5, -okno_dosk_width > * okno_scale,
                                <okno_rad, okno_thick * 0.9, okno_dosk_width> * okno_scale
				texture {
                		        pigment { pigWood1 }
                			finish { ambient 0.1 diffuse 0.2 specular 0.3 }
                			rotate y*90
                			scale 0.25
                		}
                        }
                        box {
                                <-okno_rad, okno_thick * 0.5, -okno_dosk_width > * okno_scale,
                                <okno_rad, okno_thick * 0.9, okno_dosk_width> * okno_scale
				texture {
                		        pigment { pigWood1 }
                			finish { ambient 0.05 diffuse 0.1 specular 0.3 }
                			rotate y*90
                			scale 0.25
                		}
                                rotate y*90
                        }
                }
                        
                cylinder {
                        <0, -0.01, 0>, <0, okno_thick+0.01, 0>, okno_rad - okno_kosyak_thick
                        scale okno_scale
                }
        }

        pigment {
                color red 0.2 green 0.2 blue 0.9 // filter 0.8
        }

}


///////////////////////////////////////////
// NALET
///////////////////////////////////////////

#if( showNalet )
	#declare isoObj = union {
		sphere { 0, 1 }
		#local iObj = 5;
		#while( iObj > 0 )
			cone {
				0, 0.05+0.05*rand(R1), 1+rand(R1), 0
				rotate <30*(0.5-rand(R1)),0,30*(0.5-rand(R1))>
				translate y
			}
			#local iObj = iObj - 1;
		#end
	}
	
	#declare nalet = union {
		#declare ang1 = 0;
		#declare ang2 = 0;
		#declare iNumBalls = 5000;

		#while( iNumBalls > 0 )
			#declare ang2 = maxang * rand( R1 );
			
			#if( ang2/maxang < rand( R1 ) )
					
			#declare ang1 = 220 * rand( R1 );
			#declare percent = ang2 / maxang;
			#declare currrad = begrad * (1 - percent) + percent * endrad;

			#declare sphere_rad = base_sphere_rad * 0.2 + 0.9 * base_sphere_rad * (1 - percent); 
			#declare sphere_rad = sphere_rad * rand( R1 );

			// Calculate point on the house
			#declare point1 = vtransform( <-( begrad + 2*currrad), 0, 0>, Rotate_Around_Trans( -y*ang1, <-begrad, 0, 0> ) );
			#declare point1 = vtransform( point1, Rotate_Around_Trans( -z*ang2, <0, 0, point1.z> ) );

			#declare point2 = vtransform( <-begrad, 0, 0>, Rotate_Around_Trans( -z*ang2, <0, 0, 0> ) );
			#declare norm = <0,0,0>;

			#declare inter = trace( ostov, point1, point2 - point1, norm );

			#if( vlength( norm ) != 0 )
			        #local trans = Point_At_Trans( norm );
				object {
					isoObj
					scale sphere_rad
					Point_At_Trans( norm )
					translate inter
				}
				#declare iNumBalls = iNumBalls - 1;
			#end
			#end
		#end

		// Texture for nalet
		texture {
			pigment {
				agate
				color_map {
					[0.3 color rgb <107/255, 134/255, 0/255>*<1.5,0.5,0.3>]
					[0.7 color rgb <107/255, 134/255, 0/255>*<1.2,0.5,0.3>/4]
				}
				scale 0.03
			}
			finish {
				ambient 0.1
				diffuse 0.6
				specular 0.5
			}
			normal {
				agate
				slope_map {
					[0   <0,0>]
					[0.5 <1,0>]
					[1   <0,0>]
				}
				scale 0.01
			}
		}
	}
#end

#local trubaRad = 0.2;
#local trubaLen1 = 2;
#local trubaLen2 = 0.5;
#local trubaThick = 0.02;


#declare truba = union {
	difference {
		cylinder {
			0, y*trubaLen1, trubaRad
		}
		cylinder {
			0, y*(trubaLen1+0.01), trubaRad-trubaThick
		}
		texture {
			gradient y
			texture_map {
				[0.9 texRzhavchina ]
				[0.9 texTrans ]
			}
			scale trubaLen1
			warp {
				turbulence 0.3
				octaves 7
				lambda 2
				omega 0.7
			}
		}
	}
	difference {
		cylinder {
			y*trubaLen2/4, -y*trubaLen2, trubaRad
		}
		cylinder {
			y*trubaLen2/4+0.01, -y*(trubaLen2+0.01), trubaRad-trubaThick
		}
		texture {
			gradient y
			texture_map {
				[0.2 texTrans ]
				[0.2 texRzhavchina ]
				[0.8 texRzhavchina ]
				[0.8 texTrans ]
			}
			scale trubaLen2*2
			translate y*trubaLen2.y/2
			
			warp {
				turbulence 0.3
				octaves 7
				lambda 2
				omega 0.7
			}
		}

		translate x*trubaRad
		rotate z*60
		translate x*(trubaRad-trubaThick)
		translate y*(trubaLen1-trubaThick)
	}
	scale 0.3
}

#declare hata = union {
	object {
		ostov
	}
	
	#if( showNalet )
		object {
			nalet
		}
	#end

	#if( showDver )
		object {
			dver
			scale 0.2
			rotate <75+180, -24, 90>
			translate -z*0.90
			translate -x*0.8
			translate y*0.35
		}
	#end

	#if( showOkno )
		object {
			okno
			scale 0.17
			rotate <180 + 45, -13, 90>
			translate -z*0.50
			translate -x*0.32
			translate y*0.45
		}
	#end

	object {
		truba
		rotate y*170
		rotate z*30
		rotate -y*40
		translate <-1.2, 1, -0.5>
	}
}


#end
