// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// %                                                               %
// %   IsoWood Include File version 0.3                            %
// %                                                               %
// %   iw_ex_04.pov - Sample File                                  %
// %                                                               %
// %   written August 2003                                         %
// %   by Christoph Hormann <chris_hormann@gmx.de>                 %
// %   newest version can be found at                              %
// %   http://www.tu-bs.de/~y0013390/iso_wood.html                 %
// %                                                               %
// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//
// -w800 -h600 +a0.3
// -w320 -h240 +a0.3

#version 3.5;

// ----------------------------------------

#declare IW_Quality = 2;
#declare IW_ISOmaxgrad = 7;
#declare IW_ISOmax_trace = 2;

#declare GammaFact=1.7;

#include "functions.inc"
#include "isowood3.inc"
#include "iw_textures.inc"

global_settings {
  assumed_gamma 1.0
  max_trace_level 10
}

// ----------------------------------------


camera {
  location  <0, -1.0, 6.3>
  direction z
  right     x*(image_width/image_height)
  look_at   <0.0, 0.0, 1>
  angle 12
}


light_source {
  <3500, -1200, 2400>
  color rgb <2.2, 1.8, 1.5>
}

sky_sphere {
  pigment {
    gradient z
    color_map {
      [0.0 rgb <0.6,0.7,1.0>]
      [0.2 rgb <0.2,0.3,0.9>]
    }
  }
}

// ----------------------------------------


plane {
  z, 0

  texture {
    pigment { color rgb <0.95, 1.0, 1.2> }
    finish { ambient <0.45,0.55,1.0>*0.05 diffuse 0.65 }
  }
}

// ----------------------------------------

#local fn_Brk=
  function{
    pattern{
      wrinkles 
      turbulence 0.14
      omega 0.55
      scale 0.4
    }
  }

// ====================================================
/*
object {
  IW_Cylinder_Post_RoundT (
    556,
    0.2,
    0.8,
    5, 0.4,
    0.03,
    0.05,
    pigment { Pig_IW_Weathered_Wood_01 scale 0.8 },
    texture { Tex_IW_Weathered_Wood_01 scale 0.8 }
  )
  translate -0.25*x
}
*/

// ====================================================

object {
  IW_Cylinder_Post_BrokenT (
    133,
    0.05,
    2.5,
    function { fn_Brk(x, y, z)*0.2 },
    0, 0.0,
    0.01,
    pigment { P_IW_10 },
    texture { pigment {P_IW_10 color_map{ CM_IW_06 } } finish { Fin_W } scale 0.1 }
  )
}

// ====================================================



