/* $Id: mostik.pov,v 1.3 2004/10/01 13:57:33 art Exp $ */
#declare GammaFact = 2;

#include "isowood/isowood3.inc"
#include "isowood/iw_textures.inc"

#declare fn_Brk=
  function{
    pattern{
      wrinkles 
      turbulence 0.14
      omega 0.55
      scale 0.4
    }
  }

#declare cmWood1 = color_map {
     [ 0.0000 ColorCorrect(<0.2980, 0.2196, 0.1490>, GammaFact, ColorDiff) ]
     [ 0.2000 ColorCorrect(<0.3373, 0.2471, 0.1608>, GammaFact, ColorDiff) ]
     [ 0.4000 ColorCorrect(<0.4706, 0.3451, 0.2157>, GammaFact, ColorDiff) ]
     [ 0.6000 ColorCorrect(<0.5529, 0.3922, 0.2314>, GammaFact, ColorDiff) ]
     [ 0.8000 ColorCorrect(<0.6078, 0.4118, 0.2314>, GammaFact, ColorDiff) ]
     [ 1.0000 ColorCorrect(<0.5451, 0.3843, 0.2471>, GammaFact, ColorDiff) ]
   }

#declare cmWood2 = color_map {
     [ 0.0000 ColorCorrect(<0.1980, 0.3196, 0.0490>, GammaFact, ColorDiff) ]
     [ 0.2000 ColorCorrect(<0.2373, 0.3471, 0.0608>, GammaFact, ColorDiff) ]
     [ 0.4000 ColorCorrect(<0.3706, 0.4451, 0.1157>, GammaFact, ColorDiff) ]
     [ 0.6000 ColorCorrect(<0.4529, 0.4922, 0.1314>, GammaFact, ColorDiff) ]
     [ 0.8000 ColorCorrect(<0.5078, 0.5118, 0.1314>, GammaFact, ColorDiff) ]
     [ 1.0000 ColorCorrect(<0.4451, 0.4843, 0.1471>, GammaFact, ColorDiff) ]
   }

#declare finWood = finish {
	ambient 0.08
	diffuse 0.95
	specular 0.1
	roughness 0.2
}
  
#declare texNastil = texture {
	pigment {
		gradient y
		turbulence 0.4
		pigment_map {
			[0.25 P_IW_10 color_map{ cmWood2 } scale 20 ]
			[0.5 P_IW_10 color_map{ cmWood1 } scale 20 ]
		}
	}
	finish { finWood }
	normal { Norm_W }
}

#declare texSvai = texture {
	pigment {
		gradient z
		turbulence 0.4
		pigment_map {
			[0.5 P_IW_10 color_map{ cmWood2 } scale <1,1,.2>/2 ]
			[0.63 P_IW_10 color_map{ cmWood1 } scale <1,1,.2>/2 ]
		}
	}
	finish { finWood }
	normal { Norm_W }
}

#declare pigNastil = pigment { P_IW_10  color_map{ CM_IW_04 } scale 20 };
#declare pigSvai = pigment { P_IW_10  color_map{ CM_IW_04 } scale <1,1,.2> };

#macro MakeMostik()
	union {
	#local mostikSeed = seed( 235 );
	#local mostikWidth = 1;
	#local mostikLength = 2.5;
	#local mostikHeight = 1;
	#local mostikBrevnoThick = 0.05;
	#local mostikStdBrevnoThick = 0.01;
	#local mostikSvayaThick = 0.07;
	#local mostikStdSvayaThick = 0.02;
	#local mostikMezhduSvayami = 1;
	#local mostikStdBrevnoLen = 0.025;

	#local s1 = seed( 1234 );
	// nastil
	#local P1 = <-mostikWidth/2, mostikHeight, 0>;
	#local P2 = < mostikWidth/2, mostikHeight, 0>;
	#local R = mostikBrevnoThick + ( 0.5 - rand( s1 ) ) * mostikStdBrevnoThick * 2;
	#while( P1.z < mostikLength )
	        #if( mostikDetails )
	                #local shift1 = ( 0.5 - rand( s1 ) ) * mostikStdBrevnoLen*2;
	                #local shift2 = ( 0.5 - rand( s1 ) ) * mostikStdBrevnoLen*2;
	                #local mostikBrk = 0.4 * rand( mostikSeed ); 
	                
	                object {
                          IW_Cylinder_Post_BrokenT (
                            2000*rand( mostikSeed ),
                            R,
                            ((P2.x + shift1) - (P1.x - shift2)),
                            function { fn_Brk(x, y, z) * mostikBrk },
                            5*rand( mostikSeed ), 0.4 * rand( mostikSeed ),
                            0.01+0.02*rand( mostikSeed ),
                            pigment { pigNastil scale R*2 translate y*R },
                            texture { texNastil scale R*2 translate y*R }                                
                          )

                          rotate -y * 90
                          translate -x * (P1.x + shift2)
                          translate <0,P1.y,P1.z>
                        }
	        #else
        		cylinder {
        			P1 - x*( 0.5 - rand( s1 ) ) * mostikStdBrevnoLen*2
        			P2 + x*( 0.5 - rand( s1 ) ) * mostikStdBrevnoLen*2
        			R
        			texture {
        				T_Wood2
        				rotate y*90
        				scale 0.2
        			}
        		}
		#end
		#local newR = mostikBrevnoThick + ( 0.5 - rand( s1 ) ) * mostikStdBrevnoThick * 2;
		#local P1 = P1 + z*(R+newR);
		#local P2 = P2 + z*(R+newR);
		#local R = newR;
	#end

	//svai
	#local P1 = <-mostikWidth/2 + (mostikSvayaThick+mostikStdSvayaThick), mostikHeight, mostikLength - (mostikSvayaThick+mostikStdSvayaThick)*2>;
	#local P2 = < mostikWidth/2 - (mostikSvayaThick+mostikStdSvayaThick), mostikHeight, mostikLength - (mostikSvayaThick+mostikStdSvayaThick)*2>;
	#while( P1.z > 0 )
	       #if( mostikDetails )
	                        object {
                                  IW_CylinderT (
                                    2000*rand( mostikSeed ),
                                    R,
                                    mostikHeight,
                                    5*rand( mostikSeed ), 0.4 * rand( mostikSeed ),
                                    0.01+0.02*rand( mostikSeed ),
                                    pigment { pigSvai scale mostikHeight*2 translate -z*mostikHeight },
                                    texture { texSvai scale mostikHeight*2 translate -z*mostikHeight }
                                  )
                                  rotate -x * 90
                                  translate P1*<1,0,1>
                                }
	        #else
        		cylinder {
        			P1, P1*<1,0,1>, R
        			texture {
        				T_Wood2
        				rotate x*90
        				scale 0.2
        			}
        		}
        	#end
        	
		#local R = mostikSvayaThick + ( 0.5 - rand( s1 ) ) * mostikStdSvayaThick * 2;
		
                #if( mostikDetails )
	                        object {
                                  IW_CylinderT (
                                    2000*rand( mostikSeed ),
                                    R,
                                    mostikHeight,
                                    5*rand( mostikSeed ), 0.4 * rand( mostikSeed ),
                                    0.01+0.02*rand( mostikSeed ),
                                    pigment { pigSvai scale mostikHeight*2 translate -z*mostikHeight },
                                    texture { texSvai scale mostikHeight*2 translate -z*mostikHeight }

                                  )
                                  rotate -x * 90
                                  translate P2*<1,0,1>
                                }
	        #else		
        		cylinder {
        			P2, P2*<1,0,1>, R
        			texture {
        				T_Wood2
        				rotate x*90
        				scale 0.2
        			}
        		}   
        	#end

        	#local P1 = P1 - z*(mostikMezhduSvayami);
		#local P2 = P2 - z*(mostikMezhduSvayami);
	#end
	}
#end
