/* $Id: pcmgrass.pov,v 1.2 2004/09/09 06:55:11 art Exp $ */

#macro printVector( V )
	concat( "<", str(V.x, 3, 4), ",", str(V.y, 3, 4), "," str(V.z, 3, 4), ">" )	
#end

#if( generateGrassMesh )

	#ifndef( terrain )
		#include "terrain.pov"
	#end

	#declare Object = terrain;

	#local min_ext = min_extent( Object );
	#local max_ext = max_extent( Object );
	#local n1 = <0,0,0>;
	#local n2 = <0,0,0>;
	#local n3 = <0,0,0>;
	#local n4 = <0,0,0>;
	#local statEvery = 100;
	#local statN = statEvery;
	#local dX = 0.1;
	#local dZ = 0.1;
	#local start1 = <min_ext.x, max_ext.y+1, min_ext.z>;
	#local start2 = <min_ext.x, max_ext.y+1, min_ext.z + dZ>;
	#local start3 = start1 + x*dX;
	#local start4 = start2 + x*dX;

	#fopen filehandle "grassmesh.inc" write
	#write(filehandle,"mesh{\n")

		#while (start4.z < max_ext.z)
			#while (start4.x < max_ext.x)
				#local P1 = trace( Object, start1, start1*<0,-1,0>, n1 );
				#local P2 = trace( Object, start2, start2*<0,-1,0>, n2 );
				#local P3 = trace( Object, start3, start3*<0,-1,0>, n3 );
				#local P4 = trace( Object, start4, start4*<0,-1,0>, n4 );

				#if( vlength( n1 ) != 0 )
				#if( vlength( n2 ) != 0 )
				#if( vlength( n3 ) != 0 )
				#if( vlength( n4 ) != 0 )
					#if( eval_pigment( pigGrassMask, P1 ).gray > 0.5 )
					#if( eval_pigment( pigGrassMask, P2 ).gray > 0.5 )
					#if( eval_pigment( pigGrassMask, P3 ).gray > 0.5 )
					#if( eval_pigment( pigGrassMask, P4 ).gray > 0.5 )
						#write(filehandle, concat("triangle { ", printVector(P1), ", " , printVector(P2), ", ", printVector(P3), " }\n" ) )
						#write(filehandle, concat("triangle { ", printVector(P3), ", " , printVector(P4), ", ", printVector(P2), " }\n" ) )
					#end
					#end
					#end
					#end
				#end
				#end
				#end
				#end

				#local start1 = start3;
				#local start2 = start4;
				#local start3 = start3 + x*dX;
				#local start4 = start4 + x*dX;
			#end
			#local start1 = <min_ext.x, max_ext.y+1, start1.z + dZ>;
			#local start2 = <min_ext.x, max_ext.y+1, start2.z + dZ>;
			#local start3 = start1 + x*dX;
			#local start4 = start2 + x*dX;
		#end
		#write(filehandle,"\n}")
		#fclose filehandle
		#debug "Grass mesh generation done!\n"
/*
		object {
			#include "grassmesh.inc"
					pigment{ pigGrassMask }
//			texture { texTerrain }
		}
		*/
	#end

	#if( showPCMGrass )
		// show PCM grass

		#include "pcm/pcmhair.mcr"
		#declare hair_objects_only = true;
		#declare hair_length = 0.15;
		#declare hair_radius = .1;
		#declare hair_thickness = .002;
		#declare hair_rotation = <-30, 5, 0>;
		#declare hairs_per_patch = 20;
		#declare hair_patch_size = .1;
		#declare hair_objects_per_unit = 150;
		#declare hair_texture = texture {
			normal {bumps .7 scale <.05, 1, .05>}
//			finish {phong .3 phong_size 15}
		}
		//#declare hair_pattern_pigment = pigment {bozo color_map {[0 rgb <.5, .5, .2>] [1 rgb <.1, .4, .2>]} scale .01}

		#declare hair_pattern_pigment = pigment {
			bozo
			color_map {
				[0 rgb <1, .0, .0>]
				[1 rgb <.0, 1, .0>]
			}
			scale .01
		}

		#declare apply_hair_materials_to_mesh = true;


		#declare pcmgrass = object {
			read_mesh ("grassmesh.pcm")
		}
	#end

