/* $Id: terrain.pov,v 1.9 2004/10/11 07:16:24 art Exp $ */

#declare Green1=rgb<230,170,50>/255;
#declare Green2=rgb<110,160,8>/255;
// --------------------------------------
// Grass texture
// --------------------------------------
#declare pigSpotted =pigment {
spotted
    color_map {
        [0.0, 0.2   color Tan*0.1 color Tan*0.4]
        [0.2, 0.3   color Tan*0.4 color Green1]
        [0.3, 1.01   color Green1 color Green1*1.2]
    }
}

#declare pigEarth =pigment {
    spotted
    color_map {
        [0 color Tan*0.3]
        [0.6 color Tan*0.3]
        [0.6 color Green1*0.4]
        [1   color Green1*0.4]
    }
}

#declare terrScale = <3000/200, 3.5, 2000/200>;
#declare terrOffset = <-1000/200, -1.25, -1100/200>;

#declare texTerrain = texture {
        image_pattern {
                png "bereg_mask2.png"
                map_type 0
        }
	texture_map {
		[0 pigment { color rgb <148/255, 139/255, 0> } ] // sand
		[1 pigment { pigEarth } ]
	}
	rotate x * 90
	scale terrScale
	translate terrOffset
}
/*
#declare texTerrain = texture {
	material_map {
		texture { pigment { color rgb <148/255, 139/255, 0> } }
		texture { pigment { pigEarth } }
	}
	rotate x * 90
	scale terrScale
	translate terrOffset
}*/

#declare pigGrassMask = pigment {
	image_map {
		png "bereg_grassmask1.png"
		map_type 0
		interpolate 0
		once
	}
	rotate x * 90
	scale terrScale
	translate terrOffset
}

#declare pigGiantGrassMask = pigment {
	image_map {
		png "bereg_grassmask2.png"
		map_type 0
		interpolate 0
		once
	}
	rotate x * 90
	scale terrScale
	translate terrOffset
}

#declare fn_terr = function {
        pigment {
                image_map {
                        png "bereg_f7.png" 
                        map_type 0
        		interpolate 0
        		once
		}
		rotate x * 90
        	//scale terrScale
        }
}

#declare fn_terr_noise = function {
        pigment {
                bozo
                color_map {
                        [0 Black]
                        [1 White]
                }
                scale 0.1
        }
}

#declare fn_terr_noise2 = function {
        pigment {
                agate
                color_map {
                        [0 Black]
                        [1 White]
                }
                scale 0.1
        }
}

#declare hf_cut_terr = height_field {
	png "bereg_f8.png"
	smooth
	//pigment { color Green }
	
	scale terrScale
}

#declare hf_terr = height_field {
	png "bereg_f6.png"
	smooth
	//pigment { color Blue }
	
	scale terrScale
}

#local s1 = seed( 43245 );

#local p1 = <0.01,-0.1,0.3>*terrScale;
#local p2 = <0.55,0.5,0.45>*terrScale; 
#local p3 = p2 - p1;

#local clr = array[10];

#local i = 9;
#local clr[ 0 ] = color rgb <148/255, 139/255, 0>;

#while( i > 1 )
        #local clr[ i ] = color rgb <148/255, 139/255, 0> * (0.6 + 0.4*rand( s1 ));
        #local i = i - 1;
#end

#local dlay = 0.1;
#local vlay = 0.05;
#local pos = dlay;

#local fn_crackle = function {
        pigment {
                crackle
                color_map {
                        [0 color rgb <0,0,0>]
                        [0.1 color rgb <1,1,1>]
                        [1.0 color rgb <1,1,1>*0.5]
                }
        }
}

#declare bereg = isosurface {
        function {
                z #if(showTerrDetails) - 0.2*fn_terr_noise2(x/10,y/30,z/10 ).gray - y*0.2 - 0.05 * fn_crackle(x*20,y*40,z*40).gray #end
        }
        contained_by {
                box {
                  <-p3.x/2, -p3.y/2, 0>
                  <p3.x/2, p3.y/2, 1>
                }                  
        }
        threshold 0.7
        max_gradient 21.7

        rotate y*180
        translate z*0.32
        translate ( p1 + p2 ) / 2

        texture {
                pigment {                   
                        gradient y
                        color_map {
                                [0.0 clr[ 0 ] ]
                                
                                #while( pos < 1 )
                                        [pos clr[ rand( s1 ) * 10] ]
                                        #local pos = pos + dlay + (0.5 - rand( s1 )) * vlay*2;
                                #end
                                
                                [1.0 clr[ 0 ] ]
                        }           
                        warp { turbulence <1,1,1> octaves 3 lambda 1.5 omega 0.3 }

                        scale y*0.05
                }
                finish {
                        specular 0.05
                }
        }

}

#declare terrain = object {
	bereg
        translate terrOffset
}

#declare terrain = union {
        object { hf_terr }

        intersection {        
                object { bereg }
                object { hf_cut_terr }     
        }
        
        texture {
        	tex_terrain
        	rotate x * 90
        	scale terrScale
        }
        
        translate terrOffset
}

