/* $Id: trostnik.pov,v 1.1 2004/10/11 06:29:24 art Exp $ */
#local trThick = 0.02;
#local trThickK = 0.8;
#local trNSegs = 4;
#local trSegLen = 0.6;
#local trSeed = seed( 4315 );
#local trNoise = 0.02;

#declare texTr1 = texture {
			uv_mapping
			pigment {
				gradient x
				color_map {
					[0.5 color rgb <244,230,0>/255]
					[0.5 color rgb <166,113,0>/255]
				}
			}
			finish {
				ambient 0.1
				diffuse 0.6
				specular 0.6
			}
			normal {
				gradient x 3
				slope_map {
					[0.00 <1, 0>]
					[0.25 <0, 0>]
					[0.50 <1, 0>]
					[0.75 <1, 0>]
				}
			}
			scale 0.005
		}

#declare texTr2 = texture {
			uv_mapping
			pigment {
				gradient x
				color_map {
					[0.5 color rgb <244,230,0>/255 * 0.8]
					[0.5 color rgb <166,113,0>/255 * 0.5]
				}
			}
			finish {
				ambient 0.1
				diffuse 0.6
				specular 0.3
			}
			normal {
				gradient x 3
				slope_map {
					[0.00 <1, 0>]
					[0.25 <0, 0>]
					[0.50 <1, 0>]
					[0.75 <1, 0>]
				}
			}
			scale 0.005
		}

#declare texTr = texture {
	bozo
	texture_map {
		[0.4 texTr1 scale 10]
		[0.6 texTr2 scale 10]
	}
	scale 0.1
}

#macro trostnik()
	#local trPoints = array[ trNSegs ];
	#local trThicks = array[ trNSegs ];
	#local i = 0;
	#local len = 0;
	#local thick = trThick;
	#while( i < trNSegs )
		#local len = len + trSegLen;
		#local trPoints[ i ] = <trNoise*2*(0.5-rand(trSeed)), len, trNoise*2*(0.5-rand(trSeed))>;
		#local trThicks[ i ] = thick;
		#local thick = thick * trThickK;
		#local i = i + 1;
	#end

	
	union {
		#local i = 0;
		#local prevP = <0,0,0>;
		#while( i < trNSegs )
			cylinder {
				prevP, trPoints[ i ] trThicks[ i ]
				uv_mapping
			}
			isosurface {
				function { -f_superellipsoid(x,y,z,0.9,0.4) - 0.2 * f_noise3d(x*2,y*2,z*1) }
				contained_by { box { -1.5, 1.5 } }
				uv_mapping
				rotate x*90
				scale y * 1.5
				scale trThicks[ i ] / trThickK * 1.1
				translate prevP
			}
			#local prevP = trPoints[ i ];
			#local i = i + 1;
		#end
		texture { texTr }
	}
#end

//left side
object {
	trostnik()
	rotate y * 45
	translate <1.0, -0.1, -8.0>
}
#local trThick = 0.018;
#local trSegLen = 0.7;
object {
	trostnik()
	rotate y * 45
	translate <0.65, -0.1, -7.5>
}
#local trThick = 0.016;
#local trSegLen = 0.9;
object {
	trostnik()
	rotate y * 45
	translate <0.85, -0.15, -7.5>
}

// right side
#local trThick = 0.015;
#local trSegLen = 0.6;
object {
	trostnik()
	translate <2.8, -0.15, -8.0>
}
#local trThick = 0.02;
#local trSegLen = 0.8;
object {
	trostnik()
	translate <2.77, -0.2, -7.8>
}
